searchNodes=[{"ref":"StepFlow.html","title":"StepFlow","type":"module","doc":"StepFlow provide an entire system to manage workflows.It provides differents parts: Connection with a database using Ecto to store Workflow status a connection with a message broker to interact with workers a RESTful API to create, list and interact with workflows"},{"ref":"StepFlow.html#__using__/1","title":"StepFlow.__using__/1","type":"macro","doc":"When used, dispatch to the appropriate controller/view/etc."},{"ref":"StepFlow.html#controller/0","title":"StepFlow.controller/0","type":"function","doc":"Helper to include tools in Controllers"},{"ref":"StepFlow.html#router/0","title":"StepFlow.router/0","type":"function","doc":"Helper to include tools in Router"},{"ref":"StepFlow.html#view/0","title":"StepFlow.view/0","type":"function","doc":"Helper to include tools in Views"},{"ref":"StepFlow.Amqp.CommonConsumer.html","title":"StepFlow.Amqp.CommonConsumer","type":"module","doc":"Definition of a Common Consumer of RabbitMQ queue.To implement a consumer, defmodule MyModule do use StepFlow.Amqp.CommonConsumer, %{ queue: &quot;name_of_the_rabbit_mq_queue&quot;, consumer: &amp;MyModule.consume/4 } def consume(channel, tag, redelivered, payload) do ... Basic.ack(channel, tag) end end"},{"ref":"StepFlow.Amqp.CommonEmitter.html","title":"StepFlow.Amqp.CommonEmitter","type":"module","doc":"A common emitter to send job orders to workers."},{"ref":"StepFlow.Amqp.CommonEmitter.html#publish/2","title":"StepFlow.Amqp.CommonEmitter.publish/2","type":"function","doc":"Publish a message. Example: StepFlow.Amqp.CommonEmitter.publish_json(&quot;my_rabbit_mq_queue&quot;, &quot;{\\&quot;key\\&quot;: \\&quot;value\\&quot;}&quot;)"},{"ref":"StepFlow.Amqp.CommonEmitter.html#publish_json/2","title":"StepFlow.Amqp.CommonEmitter.publish_json/2","type":"function","doc":"Publish a message using JSON serialization before send it. Example: StepFlow.Amqp.CommonEmitter.publish_json(&quot;my_rabbit_mq_queue&quot;, %{key: &quot;value&quot;})"},{"ref":"StepFlow.Amqp.CompletedConsumer.html","title":"StepFlow.Amqp.CompletedConsumer","type":"module","doc":"Consumer of all job with completed status."},{"ref":"StepFlow.Amqp.CompletedConsumer.html#child_spec/1","title":"StepFlow.Amqp.CompletedConsumer.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"StepFlow.Amqp.CompletedConsumer.html#consume/4","title":"StepFlow.Amqp.CompletedConsumer.consume/4","type":"function","doc":"Consume messages with completed topic, update Job status and continue the workflow."},{"ref":"StepFlow.Amqp.ErrorConsumer.html","title":"StepFlow.Amqp.ErrorConsumer","type":"module","doc":"Consumer of all job with error status."},{"ref":"StepFlow.Amqp.ErrorConsumer.html#child_spec/1","title":"StepFlow.Amqp.ErrorConsumer.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"StepFlow.Amqp.ErrorConsumer.html#consume/4","title":"StepFlow.Amqp.ErrorConsumer.consume/4","type":"function","doc":"Consume message with error topic, update Job and send a notification"},{"ref":"StepFlow.Amqp.Helpers.html","title":"StepFlow.Amqp.Helpers","type":"module","doc":"Helpers for AMQP."},{"ref":"StepFlow.Amqp.Helpers.html#get_amqp_connection_url/0","title":"StepFlow.Amqp.Helpers.get_amqp_connection_url/0","type":"function","doc":"Get AMQP URL from the configuration or environment variables. AMQP_HOSTNAME Setup the hostname of the RabbitMQ service AMQP_USERNAME Setup the username of the RabbitMQ service AMQP_PASSWORD Setup the password of the RabbitMQ service AMQP_PORT Setup the port of the RabbitMQ service AMQP_VHOST Setup the virtual host of the RabbitMQ service"},{"ref":"StepFlow.Amqp.Supervisor.html","title":"StepFlow.Amqp.Supervisor","type":"module","doc":"Supervisor of Step Flow. It manage AMQP connection to emir messages, consume too.It&#39;s also manage the StepManager to drive workflows."},{"ref":"StepFlow.Amqp.Supervisor.html#child_spec/1","title":"StepFlow.Amqp.Supervisor.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"StepFlow.Amqp.WorkerDiscoveryConsumer.html","title":"StepFlow.Amqp.WorkerDiscoveryConsumer","type":"module","doc":"Consumer of worker descriptions."},{"ref":"StepFlow.Amqp.WorkerDiscoveryConsumer.html#child_spec/1","title":"StepFlow.Amqp.WorkerDiscoveryConsumer.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"StepFlow.Amqp.WorkerDiscoveryConsumer.html#consume/4","title":"StepFlow.Amqp.WorkerDiscoveryConsumer.consume/4","type":"function","doc":"Consume messages, create Worker Definition if it&#39;s not already declared."},{"ref":"StepFlow.ArtifactView.html","title":"StepFlow.ArtifactView","type":"module","doc":""},{"ref":"StepFlow.ArtifactView.html#__phoenix_recompile__?/0","title":"StepFlow.ArtifactView.__phoenix_recompile__?/0","type":"function","doc":"Returns true whenever the list of templates changes in the filesystem."},{"ref":"StepFlow.ArtifactView.html#__resource__/0","title":"StepFlow.ArtifactView.__resource__/0","type":"function","doc":"The resource name, as an atom, for this view"},{"ref":"StepFlow.ArtifactView.html#__templates__/0","title":"StepFlow.ArtifactView.__templates__/0","type":"function","doc":"Returns the template root alongside all templates."},{"ref":"StepFlow.ArtifactView.html#render/2","title":"StepFlow.ArtifactView.render/2","type":"function","doc":"Renders the given template locally."},{"ref":"StepFlow.ArtifactView.html#template_not_found/2","title":"StepFlow.ArtifactView.template_not_found/2","type":"function","doc":"Callback invoked when no template is found. By default it raises but can be customized to render a particular template."},{"ref":"StepFlow.Artifacts.html","title":"StepFlow.Artifacts","type":"module","doc":"The Artifacts context."},{"ref":"StepFlow.Artifacts.html#create_artifact/1","title":"StepFlow.Artifacts.create_artifact/1","type":"function","doc":"Creates a artifact. Examples iex&gt; create_artifact(%{field: value}) {:ok, %Artifact{}} iex&gt; create_artifact(%{field: bad_value}) {:error, %Ecto.Changeset{}}"},{"ref":"StepFlow.Authorization.html","title":"StepFlow.Authorization","type":"module","doc":"StepFlow provide an entire system to manage workflows.It provides differents parts: Connection with a database using Ecto to store Workflow status a connection with a message broker to interact with workers a RESTful API to create, list and interact with workflows"},{"ref":"StepFlow.Authorization.html#call/2","title":"StepFlow.Authorization.call/2","type":"function","doc":"Callback implementation for Plug.call/2."},{"ref":"StepFlow.Authorization.html#check/1","title":"StepFlow.Authorization.check/1","type":"function","doc":"Check authorization for the connection using the method and the path. It can be configured using: config :step_flow, authorize: [ module: ExBackendWeb.Authorize, get_jobs: [:user_check, :specific_right_check] ]"},{"ref":"StepFlow.Authorization.html#init/1","title":"StepFlow.Authorization.init/1","type":"function","doc":"Callback implementation for Plug.init/1."},{"ref":"StepFlow.ChangesetView.html","title":"StepFlow.ChangesetView","type":"module","doc":""},{"ref":"StepFlow.ChangesetView.html#__phoenix_recompile__?/0","title":"StepFlow.ChangesetView.__phoenix_recompile__?/0","type":"function","doc":"Returns true whenever the list of templates changes in the filesystem."},{"ref":"StepFlow.ChangesetView.html#__resource__/0","title":"StepFlow.ChangesetView.__resource__/0","type":"function","doc":"The resource name, as an atom, for this view"},{"ref":"StepFlow.ChangesetView.html#__templates__/0","title":"StepFlow.ChangesetView.__templates__/0","type":"function","doc":"Returns the template root alongside all templates."},{"ref":"StepFlow.ChangesetView.html#render/2","title":"StepFlow.ChangesetView.render/2","type":"function","doc":"Renders the given template locally."},{"ref":"StepFlow.ChangesetView.html#template_not_found/2","title":"StepFlow.ChangesetView.template_not_found/2","type":"function","doc":"Callback invoked when no template is found. By default it raises but can be customized to render a particular template."},{"ref":"StepFlow.ChangesetView.html#translate_errors/1","title":"StepFlow.ChangesetView.translate_errors/1","type":"function","doc":"Traverses and translates changeset errors. See Ecto.Changeset.traverse_errors/2 for more details."},{"ref":"StepFlow.ErrorHelpers.html","title":"StepFlow.ErrorHelpers","type":"module","doc":"Conveniences for translating and building error messages."},{"ref":"StepFlow.ErrorHelpers.html#error_tag/2","title":"StepFlow.ErrorHelpers.error_tag/2","type":"function","doc":"Generates tag for inlined form input errors."},{"ref":"StepFlow.ErrorHelpers.html#translate_error/1","title":"StepFlow.ErrorHelpers.translate_error/1","type":"function","doc":"Translates an error message using gettext."},{"ref":"StepFlow.ErrorView.html","title":"StepFlow.ErrorView","type":"module","doc":""},{"ref":"StepFlow.ErrorView.html#__phoenix_recompile__?/0","title":"StepFlow.ErrorView.__phoenix_recompile__?/0","type":"function","doc":"Returns true whenever the list of templates changes in the filesystem."},{"ref":"StepFlow.ErrorView.html#__resource__/0","title":"StepFlow.ErrorView.__resource__/0","type":"function","doc":"The resource name, as an atom, for this view"},{"ref":"StepFlow.ErrorView.html#__templates__/0","title":"StepFlow.ErrorView.__templates__/0","type":"function","doc":"Returns the template root alongside all templates."},{"ref":"StepFlow.ErrorView.html#render/2","title":"StepFlow.ErrorView.render/2","type":"function","doc":"Renders the given template locally."},{"ref":"StepFlow.ErrorView.html#template_not_found/2","title":"StepFlow.ErrorView.template_not_found/2","type":"function","doc":"Callback invoked when no template is found. By default it raises but can be customized to render a particular template."},{"ref":"StepFlow.FallbackController.html","title":"StepFlow.FallbackController","type":"module","doc":"Translates controller action results into valid Plug.Conn responses. See Phoenix.Controller.action_fallback/1 for more details."},{"ref":"StepFlow.Gettext.html","title":"StepFlow.Gettext","type":"module","doc":"A module providing Internationalization with a gettext-based API. By using Gettext, your module gains a set of macros for translations, for example: import StepFlow.Gettext # Simple translation gettext &quot;Here is the string to translate&quot; # Plural translation ngettext &quot;Here is the string to translate&quot;, &quot;Here are the strings to translate&quot;, 3 # Domain-based translation dgettext &quot;errors&quot;, &quot;Here is the error message to translate&quot; See the Gettext Docs for detailed usage."},{"ref":"StepFlow.Gettext.html#dgettext/3","title":"StepFlow.Gettext.dgettext/3","type":"macro","doc":""},{"ref":"StepFlow.Gettext.html#dgettext_noop/2","title":"StepFlow.Gettext.dgettext_noop/2","type":"macro","doc":""},{"ref":"StepFlow.Gettext.html#dngettext/5","title":"StepFlow.Gettext.dngettext/5","type":"macro","doc":""},{"ref":"StepFlow.Gettext.html#dngettext_noop/3","title":"StepFlow.Gettext.dngettext_noop/3","type":"macro","doc":""},{"ref":"StepFlow.Gettext.html#gettext/2","title":"StepFlow.Gettext.gettext/2","type":"macro","doc":""},{"ref":"StepFlow.Gettext.html#gettext_comment/1","title":"StepFlow.Gettext.gettext_comment/1","type":"macro","doc":""},{"ref":"StepFlow.Gettext.html#gettext_noop/1","title":"StepFlow.Gettext.gettext_noop/1","type":"macro","doc":""},{"ref":"StepFlow.Gettext.html#handle_missing_bindings/2","title":"StepFlow.Gettext.handle_missing_bindings/2","type":"function","doc":"Default handling for missing bindings. This function is called when there are missing bindings in a translation. It takes a Gettext.MissingBindingsError struct and the translation with the wrong bindings left as is with the %{} syntax. For example, if something like this is called: MyApp.Gettext.gettext(&quot;Hello %{name}, welcome to %{country}&quot;, name: &quot;Jane&quot;, country: &quot;Italy&quot;) and our it/LC_MESSAGES/default.po looks like this: msgid &quot;Hello %{name}, welcome to %{country}&quot; msgstr &quot;Ciao %{name}, benvenuto in %{cowntry}&quot; # (typo) then Gettext will call: MyApp.Gettext.handle_missing_bindings(exception, &quot;Ciao Jane, benvenuto in %{cowntry}&quot;) where exception is a struct that looks like this: %Gettext.MissingBindingsError{ backend: MyApp.Gettext, domain: &quot;default&quot;, locale: &quot;it&quot;, msgid: &quot;Hello %{name}, welcome to %{country}&quot;, bindings: [:country], } The return value of the c:handle_missing_bindings/2 callback is used as the translated string that the translation macros and functions return. The default implementation for this function uses Logger.error/1 to warn about the missing binding and returns the translated message with the incomplete bindings. This function can be overridden. For example, to raise when there are missing bindings: def handle_missing_bindings(exception, _incomplete) do raise exception end Callback implementation for Gettext.Backend.handle_missing_bindings/2."},{"ref":"StepFlow.Gettext.html#handle_missing_plural_translation/6","title":"StepFlow.Gettext.handle_missing_plural_translation/6","type":"function","doc":"Default handling for plural translations with a missing translation. Same as c:handle_missing_translation/4, but for plural translations. In this case, n is the number used for pluralizing the translated string. Callback implementation for Gettext.Backend.handle_missing_plural_translation/6."},{"ref":"StepFlow.Gettext.html#handle_missing_translation/4","title":"StepFlow.Gettext.handle_missing_translation/4","type":"function","doc":"Default handling for translations with a missing translation. When a Gettext function/macro is called with a string to translate into a locale but that locale doesn&#39;t provide a translation for that string, this callback is invoked. msgid is the string that Gettext tried to translate. This function should return {:ok, translated} if a translation can be fetched or constructed for the given string, or {:default, msgid} otherwise. Callback implementation for Gettext.Backend.handle_missing_translation/4."},{"ref":"StepFlow.Gettext.html#lgettext/4","title":"StepFlow.Gettext.lgettext/4","type":"function","doc":""},{"ref":"StepFlow.Gettext.html#lngettext/6","title":"StepFlow.Gettext.lngettext/6","type":"function","doc":""},{"ref":"StepFlow.Gettext.html#ngettext/4","title":"StepFlow.Gettext.ngettext/4","type":"macro","doc":""},{"ref":"StepFlow.Gettext.html#ngettext_noop/2","title":"StepFlow.Gettext.ngettext_noop/2","type":"macro","doc":""},{"ref":"StepFlow.JobController.html","title":"StepFlow.JobController","type":"module","doc":""},{"ref":"StepFlow.JobController.html#index/2","title":"StepFlow.JobController.index/2","type":"function","doc":""},{"ref":"StepFlow.JobView.html","title":"StepFlow.JobView","type":"module","doc":""},{"ref":"StepFlow.JobView.html#__phoenix_recompile__?/0","title":"StepFlow.JobView.__phoenix_recompile__?/0","type":"function","doc":"Returns true whenever the list of templates changes in the filesystem."},{"ref":"StepFlow.JobView.html#__resource__/0","title":"StepFlow.JobView.__resource__/0","type":"function","doc":"The resource name, as an atom, for this view"},{"ref":"StepFlow.JobView.html#__templates__/0","title":"StepFlow.JobView.__templates__/0","type":"function","doc":"Returns the template root alongside all templates."},{"ref":"StepFlow.JobView.html#render/2","title":"StepFlow.JobView.render/2","type":"function","doc":"Renders the given template locally."},{"ref":"StepFlow.JobView.html#template_not_found/2","title":"StepFlow.JobView.template_not_found/2","type":"function","doc":"Callback invoked when no template is found. By default it raises but can be customized to render a particular template."},{"ref":"StepFlow.Jobs.html","title":"StepFlow.Jobs","type":"module","doc":"The Jobs context."},{"ref":"StepFlow.Jobs.html#change_job/1","title":"StepFlow.Jobs.change_job/1","type":"function","doc":"Returns an %Ecto.Changeset{} for tracking job changes. Examples iex&gt; change_job(job) %Ecto.Changeset{source: %Job{}}"},{"ref":"StepFlow.Jobs.html#create_error_job/4","title":"StepFlow.Jobs.create_error_job/4","type":"function","doc":"Creates a job with an error status. Examples iex&gt; create_error_job(workflow, step_id, &quot;download_http&quot;, &quot;unsupported step&quot;) {:ok, &quot;created&quot;}"},{"ref":"StepFlow.Jobs.html#create_job/1","title":"StepFlow.Jobs.create_job/1","type":"function","doc":"Creates a job. Examples iex&gt; create_job(%{field: value}) {:ok, %Job{}} iex&gt; create_job(%{field: bad_value}) {:error, %Ecto.Changeset{}}"},{"ref":"StepFlow.Jobs.html#create_skipped_job/3","title":"StepFlow.Jobs.create_skipped_job/3","type":"function","doc":"Creates a job with a skipped status. Examples iex&gt; create_skipped_job(workflow, 1, &quot;download_http&quot;) {:ok, &quot;skipped&quot;}"},{"ref":"StepFlow.Jobs.html#delete_job/1","title":"StepFlow.Jobs.delete_job/1","type":"function","doc":"Deletes a Job. Examples iex&gt; delete_job(job) {:ok, %Job{}} iex&gt; delete_job(job) {:error, %Ecto.Changeset{}}"},{"ref":"StepFlow.Jobs.html#get_job!/1","title":"StepFlow.Jobs.get_job!/1","type":"function","doc":"Gets a single job. Raises Ecto.NoResultsError if the Job does not exist. Examples iex&gt; get_job!(123) %Job{} iex&gt; get_job!(456) ** (Ecto.NoResultsError)"},{"ref":"StepFlow.Jobs.html#get_message/1","title":"StepFlow.Jobs.get_message/1","type":"function","doc":"Returns a formatted message for AMQP orders. Examples iex&gt; get_message(job) %{job_id: 123, parameters: [{id: &quot;input&quot;, type: &quot;string&quot;, value: &quot;/path/to/input&quot;}]}"},{"ref":"StepFlow.Jobs.html#list_jobs/1","title":"StepFlow.Jobs.list_jobs/1","type":"function","doc":"Returns the list of jobs. Examples iex&gt; list_jobs() [%Job{}, ...]"},{"ref":"StepFlow.Jobs.html#skip_jobs/3","title":"StepFlow.Jobs.skip_jobs/3","type":"function","doc":"Set skipped status to all queued jobs. Examples iex&gt; skip_jobs(workflow, step_id, &quot;download_http&quot;) :ok"},{"ref":"StepFlow.Jobs.html#update_job/2","title":"StepFlow.Jobs.update_job/2","type":"function","doc":"Updates a job. Examples iex&gt; update_job(job, %{field: new_value}) {:ok, %Job{}} iex&gt; update_job(job, %{field: bad_value}) {:error, %Ecto.Changeset{}}"},{"ref":"StepFlow.Map.html","title":"StepFlow.Map","type":"module","doc":"Extend Map with some additional functions."},{"ref":"StepFlow.Map.html#get_by_key_or_atom/3","title":"StepFlow.Map.get_by_key_or_atom/3","type":"function","doc":"Get a key matching on an atom or a string. Default value can be specified. Examples iex&gt; StepFlow.Map.get_by_key_or_atom(%{key: &quot;value&quot;}, :key) &quot;value&quot; iex&gt; StepFlow.Map.get_by_key_or_atom(%{&quot;key&quot; =&gt; &quot;value&quot;}, :key) &quot;value&quot; iex&gt; StepFlow.Map.get_by_key_or_atom(%{key: &quot;value&quot;}, &quot;key&quot;) &quot;value&quot; iex&gt; StepFlow.Map.get_by_key_or_atom(%{&quot;key&quot; =&gt; &quot;value&quot;}, &quot;key&quot;) &quot;value&quot;"},{"ref":"StepFlow.Map.html#replace_by_atom/3","title":"StepFlow.Map.replace_by_atom/3","type":"function","doc":"Replace an item in a map, with atom or string keys. Examples iex&gt; StepFlow.Map.replace_by_atom(%{key: &quot;value&quot;}, :key, &quot;replaced_value&quot;) %{key: &quot;replaced_value&quot;} iex&gt; StepFlow.Map.replace_by_atom(%{&quot;key&quot; =&gt; &quot;value&quot;}, :key, &quot;replaced_value&quot;) %{key: &quot;replaced_value&quot;} iex&gt; StepFlow.Map.replace_by_atom(%{&quot;key&quot; =&gt; &quot;value&quot;}, &quot;key&quot;, &quot;replaced_value&quot;) %{key: &quot;replaced_value&quot;}"},{"ref":"StepFlow.Notification.html","title":"StepFlow.Notification","type":"module","doc":"Send notifications to endpoint to be forwarded to websockets."},{"ref":"StepFlow.Notification.html#send/2","title":"StepFlow.Notification.send/2","type":"function","doc":""},{"ref":"StepFlow.Repo.html","title":"StepFlow.Repo","type":"module","doc":""},{"ref":"StepFlow.Repo.html#aggregate/4","title":"StepFlow.Repo.aggregate/4","type":"function","doc":"Calculate the given aggregate over the given field. If the query has a limit, offset or distinct set, it will be automatically wrapped in a subquery in order to return the proper result. Any preload or select in the query will be ignored in favor of the column being aggregated. The aggregation will fail if any group_by field is set. Options :prefix - The prefix to run the query on (such as the schema path in Postgres or the database in MySQL). This will be applied to all from and joins in the query that did not have a prefix previously given either via the :prefix option on join/from or via @schema_prefix in the schema. For more information see the &quot;Query Prefix&quot; section of the Ecto.Query documentation. See the &quot;Shared options&quot; section at the module documentation for more options. Examples # Returns the number of visits per blog post Repo.aggregate(Post, :count, :visits) # Returns the number of visits per blog post in the &quot;private&quot; schema path # (in Postgres) or database (in MySQL) Repo.aggregate(Post, :count, :visits, prefix: &quot;private&quot;) # Returns the average number of visits for the top 10 query = from Post, limit: 10 Repo.aggregate(query, :avg, :visits) Callback implementation for Ecto.Repo.aggregate/4."},{"ref":"StepFlow.Repo.html#all/2","title":"StepFlow.Repo.all/2","type":"function","doc":"Fetches all entries from the data store matching the given query. May raise Ecto.QueryError if query validation fails. Options :prefix - The prefix to run the query on (such as the schema path in Postgres or the database in MySQL). This will be applied to all from and joins in the query that did not have a prefix previously given either via the :prefix option on join/from or via @schema_prefix in the schema. For more information see the &quot;Query Prefix&quot; section of the Ecto.Query documentation. See the &quot;Shared options&quot; section at the module documentation for more options. Example # Fetch all post titles query = from p in Post, select: p.title MyRepo.all(query) Callback implementation for Ecto.Repo.all/2."},{"ref":"StepFlow.Repo.html#checkout/2","title":"StepFlow.Repo.checkout/2","type":"function","doc":"Checks out a connection for the duration of the function. It returns the result of the function. This is useful when you need to perform multiple operations against the repository in a row and you want to avoid checking out the connection multiple times. checkout/2 and transaction/2 can be combined and nested multiple times. If checkout/2 is called inside the function of another checkout/2 call, the function is simply executed, without checking out a new connection. Options See the &quot;Shared options&quot; section at the module documentation for more options. Callback implementation for Ecto.Repo.checkout/2."},{"ref":"StepFlow.Repo.html#child_spec/1","title":"StepFlow.Repo.child_spec/1","type":"function","doc":""},{"ref":"StepFlow.Repo.html#config/0","title":"StepFlow.Repo.config/0","type":"function","doc":"Returns the adapter configuration stored in the :otp_app environment. If the c:init/2 callback is implemented in the repository, it will be invoked with the first argument set to :runtime. Callback implementation for Ecto.Repo.config/0."},{"ref":"StepFlow.Repo.html#delete/2","title":"StepFlow.Repo.delete/2","type":"function","doc":"Deletes a struct using its primary key. If the struct has no primary key, Ecto.NoPrimaryKeyFieldError will be raised. If the struct has been removed from db prior to call, Ecto.StaleEntryError will be raised. It returns {:ok, struct} if the struct has been successfully deleted or {:error, changeset} if there was a validation or a known constraint error. Options :prefix - The prefix to run the query on (such as the schema path in Postgres or the database in MySQL). This overrides the prefix set in the query and any @schema_prefix set in the schema. :stale_error_field - The field where stale errors will be added in the returning changeset. This option can be used to avoid raising Ecto.StaleEntryError. :stale_error_message - The message to add to the configured :stale_error_field when stale errors happen, defaults to &quot;is stale&quot;. See the &quot;Shared options&quot; section at the module documentation for more options. Example post = MyRepo.get!(Post, 42) case MyRepo.delete post do {:ok, struct} -&gt; # Deleted with success {:error, changeset} -&gt; # Something went wrong end Callback implementation for Ecto.Repo.delete/2."},{"ref":"StepFlow.Repo.html#delete!/2","title":"StepFlow.Repo.delete!/2","type":"function","doc":"Same as c:delete/2 but returns the struct or raises if the changeset is invalid. Callback implementation for Ecto.Repo.delete!/2."},{"ref":"StepFlow.Repo.html#delete_all/2","title":"StepFlow.Repo.delete_all/2","type":"function","doc":"Deletes all entries matching the given query. It returns a tuple containing the number of entries and any returned result as second element. The second element is nil by default unless a select is supplied in the update query. Note, however, not all databases support returning data from DELETEs. Options :prefix - The prefix to run the query on (such as the schema path in Postgres or the database in MySQL). This overrides the prefix set in the query and any @schema_prefix set in the schema. See the &quot;Shared options&quot; section at the module documentation for remaining options. Examples MyRepo.delete_all(Post) from(p in Post, where: p.id &lt; 10) |&gt; MyRepo.delete_all Callback implementation for Ecto.Repo.delete_all/2."},{"ref":"StepFlow.Repo.html#exists?/2","title":"StepFlow.Repo.exists?/2","type":"function","doc":"Checks if there exists an entry that matches the given query. Returns a boolean. Options :prefix - The prefix to run the query on (such as the schema path in Postgres or the database in MySQL). This will be applied to all from and joins in the query that did not have a prefix previously given either via the :prefix option on join/from or via @schema_prefix in the schema. For more information see the &quot;Query Prefix&quot; section of the Ecto.Query documentation. See the &quot;Shared options&quot; section at the module documentation for more options. Examples # checks if any posts exist Repo.exists?(Post) # checks if any posts exist in the &quot;private&quot; schema path (in Postgres) or # database (in MySQL) Repo.exists?(Post, schema: &quot;private&quot;) # checks if any post with a like count greater than 10 exists query = from p in Post, where: p.like_count &gt; 10 Repo.exists?(query) Callback implementation for Ecto.Repo.exists?/2."},{"ref":"StepFlow.Repo.html#get/3","title":"StepFlow.Repo.get/3","type":"function","doc":"Fetches a single struct from the data store where the primary key matches the given id. Returns nil if no result was found. If the struct in the queryable has no or more than one primary key, it will raise an argument error. Options :prefix - The prefix to run the query on (such as the schema path in Postgres or the database in MySQL). This will be applied to all from and joins in the query that did not have a prefix previously given either via the :prefix option on join/from or via @schema_prefix in the schema. For more information see the &quot;Query Prefix&quot; section of the Ecto.Query documentation. See the &quot;Shared options&quot; section at the module documentation for more options. Example MyRepo.get(Post, 42) MyRepo.get(Post, 42, prefix: &quot;public&quot;) Callback implementation for Ecto.Repo.get/3."},{"ref":"StepFlow.Repo.html#get!/3","title":"StepFlow.Repo.get!/3","type":"function","doc":"Similar to c:get/3 but raises Ecto.NoResultsError if no record was found. Options :prefix - The prefix to run the query on (such as the schema path in Postgres or the database in MySQL). This will be applied to all from and joins in the query that did not have a prefix previously given either via the :prefix option on join/from or via @schema_prefix in the schema. For more information see the &quot;Query Prefix&quot; section of the Ecto.Query documentation. See the &quot;Shared options&quot; section at the module documentation for more options. Example MyRepo.get!(Post, 42) MyRepo.get!(Post, 42, prefix: &quot;public&quot;) Callback implementation for Ecto.Repo.get!/3."},{"ref":"StepFlow.Repo.html#get_by/3","title":"StepFlow.Repo.get_by/3","type":"function","doc":"Fetches a single result from the query. Returns nil if no result was found. Raises if more than one entry. Options :prefix - The prefix to run the query on (such as the schema path in Postgres or the database in MySQL). This will be applied to all from and joins in the query that did not have a prefix previously given either via the :prefix option on join/from or via @schema_prefix in the schema. For more information see the &quot;Query Prefix&quot; section of the Ecto.Query documentation. See the &quot;Shared options&quot; section at the module documentation for more options. Example MyRepo.get_by(Post, title: &quot;My post&quot;) MyRepo.get_by(Post, [title: &quot;My post&quot;], prefix: &quot;public&quot;) Callback implementation for Ecto.Repo.get_by/3."},{"ref":"StepFlow.Repo.html#get_by!/3","title":"StepFlow.Repo.get_by!/3","type":"function","doc":"Similar to c:get_by/3 but raises Ecto.NoResultsError if no record was found. Raises if more than one entry. Options :prefix - The prefix to run the query on (such as the schema path in Postgres or the database in MySQL). This will be applied to all from and joins in the query that did not have a prefix previously given either via the :prefix option on join/from or via @schema_prefix in the schema. For more information see the &quot;Query Prefix&quot; section of the Ecto.Query documentation. See the &quot;Shared options&quot; section at the module documentation for more options. Example MyRepo.get_by!(Post, title: &quot;My post&quot;) MyRepo.get_by!(Post, [title: &quot;My post&quot;], prefix: &quot;public&quot;) Callback implementation for Ecto.Repo.get_by!/3."},{"ref":"StepFlow.Repo.html#get_dynamic_repo/0","title":"StepFlow.Repo.get_dynamic_repo/0","type":"function","doc":"Returns the atom name or pid of the current repository. See c:put_dynamic_repo/1 for more information. Callback implementation for Ecto.Repo.get_dynamic_repo/0."},{"ref":"StepFlow.Repo.html#in_transaction?/0","title":"StepFlow.Repo.in_transaction?/0","type":"function","doc":"Returns true if the current process is inside a transaction. If you are using the Ecto.Adapters.SQL.Sandbox in tests, note that even though each test is inside a transaction, in_transaction?/0 will only return true inside transactions explicitly created with transaction/2. This is done so the test environment mimics dev and prod. If you are trying to debug transaction-related code while using Ecto.Adapters.SQL.Sandbox, it may be more helpful to configure the database to log all statements and consult those logs. Examples MyRepo.in_transaction? #=&gt; false MyRepo.transaction(fn -&gt; MyRepo.in_transaction? #=&gt; true end) Callback implementation for Ecto.Repo.in_transaction?/0."},{"ref":"StepFlow.Repo.html#insert/2","title":"StepFlow.Repo.insert/2","type":"function","doc":"Inserts a struct defined via Ecto.Schema or a changeset. In case a struct is given, the struct is converted into a changeset with all non-nil fields as part of the changeset. In case a changeset is given, the changes in the changeset are merged with the struct fields, and all of them are sent to the database. It returns {:ok, struct} if the struct has been successfully inserted or {:error, changeset} if there was a validation or a known constraint error. Options :returning - selects which fields to return. It accepts a list of fields to be returned from the database. When true, returns all fields. When false, no extra fields are returned. It will always include all fields in read_after_writes as well as any autogenerated id. Not all databases support this option. :prefix - The prefix to run the query on (such as the schema path in Postgres or the database in MySQL). This overrides the prefix set in the query and any @schema_prefix set any schemas. Also, the @schema_prefix for the parent record will override all default @schema_prefixs set in any child schemas for associations. :on_conflict - It may be one of :raise (the default), :nothing, :replace_all, :replace_all_except_primary_key, {:replace, fields}, a keyword list of update instructions or an Ecto.Query query for updates. See the &quot;Upserts&quot; section for more information. :conflict_target - A list of column names to verify for conflicts. It is expected those columns to have unique indexes on them that may conflict. If none is specified, the conflict target is left up to the database. May also be {:constraint, constraint_name_as_atom} in databases that support the &quot;ON CONSTRAINT&quot; expression, such as PostgreSQL. :stale_error_field - The field where stale errors will be added in the returning changeset. This option can be used to avoid raising Ecto.StaleEntryError. :stale_error_message - The message to add to the configured :stale_error_field when stale errors happen, defaults to &quot;is stale&quot;. See the &quot;Shared options&quot; section at the module documentation for more options. Examples A typical example is calling MyRepo.insert/1 with a struct and acting on the return value: case MyRepo.insert %Post{title: &quot;Ecto is great&quot;} do {:ok, struct} -&gt; # Inserted with success {:error, changeset} -&gt; # Something went wrong end Upserts c:insert/2 provides upserts (update or inserts) via the :on_conflict option. The :on_conflict option supports the following values: :raise - raises if there is a conflicting primary key or unique index :nothing - ignores the error in case of conflicts :replace_all - replace all values on the existing row with the values in the schema/changeset, including autogenerated fields such as inserted_at and updated_at :replace_all_except_primary_key - same as above except primary keys are not replaced {:replace, fields} - replace only specific columns. This option requires conflict_target a keyword list of update instructions - such as the one given to c:update_all/3, for example: [set: [title: &quot;new title&quot;]] an Ecto.Query that will act as an UPDATE statement, such as the one given to c:update_all/3. If the struct cannot be found, Ecto.StaleEntryError will be raised. Upserts map to &quot;ON CONFLICT&quot; on databases like Postgres and &quot;ON DUPLICATE KEY&quot; on databases such as MySQL. As an example, imagine :title is marked as a unique column in the database: {:ok, inserted} = MyRepo.insert(%Post{title: &quot;this is unique&quot;}) Now we can insert with the same title but do nothing on conflicts: {:ok, ignored} = MyRepo.insert(%Post{title: &quot;this is unique&quot;}, on_conflict: :nothing) assert ignored.id == nil Because we used on_conflict: :nothing, instead of getting an error, we got {:ok, struct}. However the returned struct does not reflect the data in the database. One possible mechanism to detect if an insert or nothing happened in case of on_conflict: :nothing is by checking the id field. id will be nil if the field is autogenerated by the database and no insert happened. For actual upserts, where an insert or update may happen, the situation is slightly more complex, as the database does not actually inform us if an insert or update happened. Let&#39;s insert a post with the same title but use a query to update the body column in case of conflicts: # In Postgres (it requires the conflict target for updates): on_conflict = [set: [body: &quot;updated&quot;]] {:ok, updated} = MyRepo.insert(%Post{title: &quot;this is unique&quot;}, on_conflict: on_conflict, conflict_target: :title) # In MySQL (conflict target is not supported): on_conflict = [set: [title: &quot;updated&quot;]] {:ok, updated} = MyRepo.insert(%Post{id: inserted.id, title: &quot;updated&quot;}, on_conflict: on_conflict) In the examples above, even though it returned :ok, we do not know if we inserted new data or if we updated only the :on_conflict fields. In case an update happened, the data in the struct most likely does not match the data in the database. For example, autogenerated fields such as inserted_at will point to now rather than the time the struct was actually inserted. If you need to guarantee the data in the returned struct mirrors the database, you have three options: Use on_conflict: :replace_all, although that will replace all fields in the database with the ones in the struct/changeset, including autogenerated fields such as insert_at and updated_at: MyRepo.insert(%Post{title: &quot;this is unique&quot;}, on_conflict: :replace_all, conflict_target: :title) Specify read_after_writes: true in your schema for choosing fields that are read from the database after every operation. Or pass returning: true to insert to read all fields back: MyRepo.insert(%Post{title: &quot;this is unique&quot;}, returning: true, on_conflict: on_conflict, conflict_target: :title) Alternatively, read the data again from the database in a separate query. This option requires the primary key to be generated by the database: {:ok, updated} = MyRepo.insert(%Post{title: &quot;this is unique&quot;}, on_conflict: on_conflict) Repo.get(Post, updated.id) Because of the inability to know if the struct is up to date or not, inserting a struct with associations and using the :on_conflict option at the same time is not recommended, as Ecto will be unable to actually track the proper status of the association. Callback implementation for Ecto.Repo.insert/2."},{"ref":"StepFlow.Repo.html#insert!/2","title":"StepFlow.Repo.insert!/2","type":"function","doc":"Same as c:insert/2 but returns the struct or raises if the changeset is invalid. Callback implementation for Ecto.Repo.insert!/2."},{"ref":"StepFlow.Repo.html#insert_all/3","title":"StepFlow.Repo.insert_all/3","type":"function","doc":"Inserts all entries into the repository. It expects a schema module (MyApp.User) or a source (&quot;users&quot;) or both ({&quot;users&quot;, MyApp.User}) as the first argument. The second argument is a list of entries to be inserted, either as keyword lists or as maps. The keys of the entries are the field names as atoms and the value should be the respective value for the field type or, optionally, an Ecto.Query that returns a single entry with a single value. It returns a tuple containing the number of entries and any returned result as second element. If the database does not support RETURNING in INSERT statements or no return result was selected, the second element will be nil. When a schema module is given, the entries given will be properly dumped before being sent to the database. If the schema contains an autogenerated ID field, it will be handled either at the adapter or the storage layer. However any other autogenerated value, like timestamps, won&#39;t be autogenerated when using c:insert_all/3. This is by design as this function aims to be a more direct way to insert data into the database without the conveniences of c:insert/2. This is also consistent with c:update_all/3 that does not handle timestamps as well. It is also not possible to use insert_all to insert across multiple tables, therefore associations are not supported. If a source is given, without a schema module, the given fields are passed as is to the adapter. Options :returning - selects which fields to return. When true, returns all fields in the given schema. May be a list of fields, where a struct is still returned but only with the given fields. Or false, where nothing is returned (the default). This option is not supported by all databases. :prefix - The prefix to run the query on (such as the schema path in Postgres or the database in MySQL). This overrides the prefix set in the query and any @schema_prefix set in the schema. :on_conflict - It may be one of :raise (the default), :nothing, :replace_all, :replace_all_except_primary_key, {:replace, fields}, a keyword list of update instructions or an Ecto.Query query for updates. See the &quot;Upserts&quot; section for more information. :conflict_target - A list of column names to verify for conflicts. It is expected those columns to have unique indexes on them that may conflict. If none is specified, the conflict target is left up to the database. It may also be {:constraint, constraint_name_as_atom} in databases that support the &quot;ON CONSTRAINT&quot; expression, such as PostgreSQL, or {:unsafe_fragment, binary_fragment} to pass any expression to the database without any sanitization, such as ON CONFLICT (coalesce(firstname, &quot;&quot;), coalesce(lastname, &quot;&quot;)). See the &quot;Shared options&quot; section at the module documentation for remaining options. Examples MyRepo.insert_all(Post, [[title: &quot;My first post&quot;], [title: &quot;My second post&quot;]]) MyRepo.insert_all(Post, [%{title: &quot;My first post&quot;}, %{title: &quot;My second post&quot;}]) Upserts c:insert_all/3 provides upserts (update or inserts) via the :on_conflict option. The :on_conflict option supports the following values: :raise - raises if there is a conflicting primary key or unique index :nothing - ignores the error in case of conflicts :replace_all - replace all values on the existing row by the new entry, including values not sent explicitly by Ecto, such as database defaults. This option requires a schema :replace_all_except_primary_key - same as above except primary keys are not replaced. This option requires a schema {:replace, fields} - replace only specific columns. This option requires conflict_target a keyword list of update instructions - such as the one given to c:update_all/3, for example: [set: [title: &quot;new title&quot;]] an Ecto.Query that will act as an UPDATE statement, such as the one given to c:update_all/3 Upserts map to &quot;ON CONFLICT&quot; on databases like Postgres and &quot;ON DUPLICATE KEY&quot; on databases such as MySQL. Return values By default, both Postgres and MySQL return the amount of entries inserted on c:insert_all/3. However, when the :on_conflict option is specified, Postgres will only return a row if it was affected while MySQL returns at least the number of entries attempted. For example, if :on_conflict is set to :nothing, Postgres will return 0 if no new entry was added while MySQL will still return the amount of entries attempted to be inserted, even if no entry was added. Even worse, if :on_conflict is query, MySQL will return the number of attempted entries plus the number of entries modified by the UPDATE query. Callback implementation for Ecto.Repo.insert_all/3."},{"ref":"StepFlow.Repo.html#insert_or_update/2","title":"StepFlow.Repo.insert_or_update/2","type":"function","doc":"Inserts or updates a changeset depending on whether the struct is persisted or not. The distinction whether to insert or update will be made on the Ecto.Schema.Metadata field :state. The :state is automatically set by Ecto when loading or building a schema. Please note that for this to work, you will have to load existing structs from the database. So even if the struct exists, this won&#39;t work: struct = %Post{id: &quot;existing_id&quot;, ...} MyRepo.insert_or_update changeset # =&gt; {:error, changeset} # id already exists Options :prefix - The prefix to run the query on (such as the schema path in Postgres or the database in MySQL). This overrides the prefix set in the query and any @schema_prefix set any schemas. Also, the @schema_prefix for the parent record will override all default @schema_prefixs set in any child schemas for associations. :stale_error_field - The field where stale errors will be added in the returning changeset. This option can be used to avoid raising Ecto.StaleEntryError. Only applies to updates. :stale_error_message - The message to add to the configured :stale_error_field when stale errors happen, defaults to &quot;is stale&quot;. Only applies to updates. See the &quot;Shared options&quot; section at the module documentation for more options. Example result = case MyRepo.get(Post, id) do nil -&gt; %Post{id: id} # Post not found, we build one post -&gt; post # Post exists, let&#39;s use it end |&gt; Post.changeset(changes) |&gt; MyRepo.insert_or_update case result do {:ok, struct} -&gt; # Inserted or updated with success {:error, changeset} -&gt; # Something went wrong end Callback implementation for Ecto.Repo.insert_or_update/2."},{"ref":"StepFlow.Repo.html#insert_or_update!/2","title":"StepFlow.Repo.insert_or_update!/2","type":"function","doc":"Same as c:insert_or_update/2 but returns the struct or raises if the changeset is invalid. Callback implementation for Ecto.Repo.insert_or_update!/2."},{"ref":"StepFlow.Repo.html#load/2","title":"StepFlow.Repo.load/2","type":"function","doc":"Loads data into a struct or a map. The first argument can be a a schema module, or a map (of types) and determines the return value: a struct or a map, respectively. The second argument data specifies fields and values that are to be loaded. It can be a map, a keyword list, or a {fields, values} tuple. Fields can be atoms or strings. Fields that are not present in the schema (or types map) are ignored. If any of the values has invalid type, an error is raised. Examples iex&gt; MyRepo.load(User, %{name: &quot;Alice&quot;, age: 25}) %User{name: &quot;Alice&quot;, age: 25} iex&gt; MyRepo.load(User, [name: &quot;Alice&quot;, age: 25]) %User{name: &quot;Alice&quot;, age: 25} data can also take form of {fields, values}: iex&gt; MyRepo.load(User, {[:name, :age], [&quot;Alice&quot;, 25]}) %User{name: &quot;Alice&quot;, age: 25, ...} The first argument can also be a types map: iex&gt; types = %{name: :string, age: :integer} iex&gt; MyRepo.load(types, %{name: &quot;Alice&quot;, age: 25}) %{name: &quot;Alice&quot;, age: 25} This function is especially useful when parsing raw query results: iex&gt; result = Ecto.Adapters.SQL.query!(MyRepo, &quot;SELECT * FROM users&quot;, []) iex&gt; Enum.map(result.rows, &amp;MyRepo.load(User, {result.columns, &amp;1})) [%User{...}, ...] Callback implementation for Ecto.Repo.load/2."},{"ref":"StepFlow.Repo.html#one/2","title":"StepFlow.Repo.one/2","type":"function","doc":"Fetches a single result from the query. Returns nil if no result was found. Raises if more than one entry. Options :prefix - The prefix to run the query on (such as the schema path in Postgres or the database in MySQL). This will be applied to all from and joins in the query that did not have a prefix previously given either via the :prefix option on join/from or via @schema_prefix in the schema. For more information see the &quot;Query Prefix&quot; section of the Ecto.Query documentation. See the &quot;Shared options&quot; section at the module documentation for more options. Examples Repo.one(Post) Repo.one(from p in Post, where: p.like_count &gt; 10) query = from p in Post, where: p.like_count &gt; 10 Repo.one(query, prefix: &quot;private&quot;) Callback implementation for Ecto.Repo.one/2."},{"ref":"StepFlow.Repo.html#one!/2","title":"StepFlow.Repo.one!/2","type":"function","doc":"Similar to c:one/2 but raises Ecto.NoResultsError if no record was found. Raises if more than one entry. Options :prefix - The prefix to run the query on (such as the schema path in Postgres or the database in MySQL). This will be applied to all from and joins in the query that did not have a prefix previously given either via the :prefix option on join/from or via @schema_prefix in the schema. For more information see the &quot;Query Prefix&quot; section of the Ecto.Query documentation. See the &quot;Shared options&quot; section at the module documentation for more options. Callback implementation for Ecto.Repo.one!/2."},{"ref":"StepFlow.Repo.html#preload/3","title":"StepFlow.Repo.preload/3","type":"function","doc":"Preloads all associations on the given struct or structs. This is similar to Ecto.Query.preload/3 except it allows you to preload structs after they have been fetched from the database. In case the association was already loaded, preload won&#39;t attempt to reload it. Options :force - By default, Ecto won&#39;t preload associations that are already loaded. By setting this option to true, any existing association will be discarded and reloaded. :in_parallel - If the preloads must be done in parallel. It can only be performed when we have more than one preload and the repository is not in a transaction. Defaults to true. :prefix - the prefix to fetch preloads from. By default, queries will use the same prefix as the one in the given collection. This option allows the prefix to be changed. See the &quot;Shared options&quot; section at the module documentation for more options. Examples # Use a single atom to preload an association posts = Repo.preload posts, :comments # Use a list of atoms to preload multiple associations posts = Repo.preload posts, [:comments, :authors] # Use a keyword list to preload nested associations as well posts = Repo.preload posts, [comments: [:replies, :likes], authors: []] # Use a keyword list to customize how associations are queried posts = Repo.preload posts, [comments: from(c in Comment, order_by: c.published_at)] # Use a two-element tuple for a custom query and nested association definition query = from c in Comment, order_by: c.published_at posts = Repo.preload posts, [comments: {query, [:replies, :likes]}] The query given to preload may also preload its own associations. Callback implementation for Ecto.Repo.preload/3."},{"ref":"StepFlow.Repo.html#prepare_query/3","title":"StepFlow.Repo.prepare_query/3","type":"function","doc":"A user customizable callback invoked for query-based operations. This callback can be used to further modify the query and options before it is transformed and sent to the database. This callback is invoked for all query APIs, including the stream function, but it is not invoked for insert_all nor any of the schema functions. Callback implementation for Ecto.Repo.prepare_query/3."},{"ref":"StepFlow.Repo.html#put_dynamic_repo/1","title":"StepFlow.Repo.put_dynamic_repo/1","type":"function","doc":"Sets the dynamic repository to be used in further interactions. Sometimes you may want a single Ecto repository to talk to many different database instances. By default, when you call MyApp.Repo.start_link/1, it will start a repository with name MyApp.Repo. But if you want to start multiple repositories, you can give each of them a different name: MyApp.Repo.start_link(name: :tenant_foo, hostname: &quot;foo.example.com&quot;) MyApp.Repo.start_link(name: :tenant_bar, hostname: &quot;bar.example.com&quot;) You can also start repositories without names by explicitly setting the name to nil: MyApp.Repo.start_link(name: nil, hostname: &quot;temp.example.com&quot;) However, once the repository is started, you can&#39;t directly interact with it, since all operations in MyApp.Repo are sent by default to the repository named MyApp.Repo. You can change the default repo at compile time with: use Ecto.Repo, default_dynamic_repo: :name_of_repo Or you can change it anytime at runtime by calling put_dynamic_repo/1: MyApp.Repo.put_dynamic_repo(:tenant_foo) From this moment on, all future queries done by the current process will run on :tenant_foo. Note this feature is experimental and may be changed or removed in future releases. Callback implementation for Ecto.Repo.put_dynamic_repo/1."},{"ref":"StepFlow.Repo.html#query/3","title":"StepFlow.Repo.query/3","type":"function","doc":"A convenience function for SQL-based repositories that executes the given query. See Ecto.Adapters.SQL.query/4 for more information."},{"ref":"StepFlow.Repo.html#query!/3","title":"StepFlow.Repo.query!/3","type":"function","doc":"A convenience function for SQL-based repositories that executes the given query. See Ecto.Adapters.SQL.query!/4 for more information."},{"ref":"StepFlow.Repo.html#rollback/1","title":"StepFlow.Repo.rollback/1","type":"function","doc":"Rolls back the current transaction. The transaction will return the value given as {:error, value}. Callback implementation for Ecto.Repo.rollback/1."},{"ref":"StepFlow.Repo.html#start_link/1","title":"StepFlow.Repo.start_link/1","type":"function","doc":"Starts any connection pooling or supervision and return {:ok, pid} or just :ok if nothing needs to be done. Returns {:error, {:already_started, pid}} if the repo is already started or {:error, term} in case anything else goes wrong. Options See the configuration in the moduledoc for options shared between adapters, for adapter-specific configuration see the adapter&#39;s documentation. Callback implementation for Ecto.Repo.start_link/1."},{"ref":"StepFlow.Repo.html#stop/1","title":"StepFlow.Repo.stop/1","type":"function","doc":"Shuts down the repository. Callback implementation for Ecto.Repo.stop/1."},{"ref":"StepFlow.Repo.html#stream/2","title":"StepFlow.Repo.stream/2","type":"function","doc":"Returns a lazy enumerable that emits all entries from the data store matching the given query. SQL adapters, such as Postgres and MySQL, can only enumerate a stream inside a transaction. May raise Ecto.QueryError if query validation fails. Options :prefix - The prefix to run the query on (such as the schema path in Postgres or the database in MySQL). This will be applied to all from and joins in the query that did not have a prefix previously given either via the :prefix option on join/from or via @schema_prefix in the schema. For more information see the &quot;Query Prefix&quot; section of the Ecto.Query documentation. :max_rows - The number of rows to load from the database as we stream. It is supported at least by Postgres and MySQL and defaults to 500. See the &quot;Shared options&quot; section at the module documentation for more options. Example # Fetch all post titles query = from p in Post, select: p.title stream = MyRepo.stream(query) MyRepo.transaction(fn() -&gt; Enum.to_list(stream) end) Callback implementation for Ecto.Repo.stream/2."},{"ref":"StepFlow.Repo.html#to_sql/2","title":"StepFlow.Repo.to_sql/2","type":"function","doc":"A convenience function for SQL-based repositories that translates the given query to SQL. See Ecto.Adapters.SQL.to_sql/3 for more information."},{"ref":"StepFlow.Repo.html#transaction/2","title":"StepFlow.Repo.transaction/2","type":"function","doc":"Runs the given function or Ecto.Multi inside a transaction. Use with function c:transaction/2 can be called with both a function of arity zero or one. The arity zero function will just be executed as is, while the arity one function will receive the repo of the transaction as its first argument, similar to Ecto.Multi.run. If an unhandled error occurs the transaction will be rolled back and the error will bubble up from the transaction function. If no error occurred the transaction will be committed when the function returns. A transaction can be explicitly rolled back by calling c:rollback/1, this will immediately leave the function and return the value given to rollback as {:error, value}. A successful transaction returns the value returned by the function wrapped in a tuple as {:ok, value}. If c:transaction/2 is called inside another transaction, the function is simply executed, without wrapping the new transaction call in any way. If there is an error in the inner transaction and the error is rescued, or the inner transaction is rolled back, the whole outer transaction is marked as tainted, guaranteeing nothing will be committed. Use with Ecto.Multi Besides functions transaction can be used with an Ecto.Multi struct. Transaction will be started, all operations applied and in case of success committed returning {:ok, changes}. In case of any errors the transaction will be rolled back and {:error, failed_operation, failed_value, changes_so_far} will be returned. You can read more about using transactions with Ecto.Multi as well as see some examples in the Ecto.Multi documentation. Options See the &quot;Shared options&quot; section at the module documentation for more options. Examples import Ecto.Changeset, only: [change: 2] MyRepo.transaction(fn -&gt; MyRepo.update!(change(alice, balance: alice.balance - 10)) MyRepo.update!(change(bob, balance: bob.balance + 10)) end) # When passing a function of arity 1, it receives the repository itself MyRepo.transaction(fn repo -&gt; repo.insert!(%Post{}) end) # Roll back a transaction explicitly MyRepo.transaction(fn -&gt; p = MyRepo.insert!(%Post{}) if not Editor.post_allowed?(p) do MyRepo.rollback(:posting_not_allowed) end end) # With Ecto.Multi Ecto.Multi.new |&gt; Ecto.Multi.insert(:post, %Post{}) |&gt; MyRepo.transaction Callback implementation for Ecto.Repo.transaction/2."},{"ref":"StepFlow.Repo.html#update/2","title":"StepFlow.Repo.update/2","type":"function","doc":"Updates a changeset using its primary key. A changeset is required as it is the only mechanism for tracking dirty changes. Only the fields present in the changes part of the changeset are sent to the database. Any other, in-memory changes done to the schema are ignored. If the struct has no primary key, Ecto.NoPrimaryKeyFieldError will be raised. If the struct cannot be found, Ecto.StaleEntryError will be raised. It returns {:ok, struct} if the struct has been successfully updated or {:error, changeset} if there was a validation or a known constraint error. Options :returning - selects which fields to return. It accepts a list of fields to be returned from the database. When true, returns all fields. When false, no extra fields are returned. It will always include all fields in read_after_writes. Not all databases support this option. :force - By default, if there are no changes in the changeset, c:update/2 is a no-op. By setting this option to true, update callbacks will always be executed, even if there are no changes (including timestamps). :prefix - The prefix to run the query on (such as the schema path in Postgres or the database in MySQL). This overrides the prefix set in the query and any @schema_prefix set any schemas. Also, the @schema_prefix for the parent record will override all default @schema_prefixs set in any child schemas for associations. :stale_error_field - The field where stale errors will be added in the returning changeset. This option can be used to avoid raising Ecto.StaleEntryError. :stale_error_message - The message to add to the configured :stale_error_field when stale errors happen, defaults to &quot;is stale&quot;. See the &quot;Shared options&quot; section at the module documentation for more options. Example post = MyRepo.get!(Post, 42) post = Ecto.Changeset.change post, title: &quot;New title&quot; case MyRepo.update post do {:ok, struct} -&gt; # Updated with success {:error, changeset} -&gt; # Something went wrong end Callback implementation for Ecto.Repo.update/2."},{"ref":"StepFlow.Repo.html#update!/2","title":"StepFlow.Repo.update!/2","type":"function","doc":"Same as c:update/2 but returns the struct or raises if the changeset is invalid. Callback implementation for Ecto.Repo.update!/2."},{"ref":"StepFlow.Repo.html#update_all/3","title":"StepFlow.Repo.update_all/3","type":"function","doc":"Updates all entries matching the given query with the given values. It returns a tuple containing the number of entries and any returned result as second element. The second element is nil by default unless a select is supplied in the update query. Note, however, not all databases support returning data from UPDATEs. Keep in mind this update_all will not update autogenerated fields like the updated_at columns. See Ecto.Query.update/3 for update operations that can be performed on fields. Options :prefix - The prefix to run the query on (such as the schema path in Postgres or the database in MySQL). This overrides the prefix set in the query and any @schema_prefix set in the schema. See the &quot;Shared options&quot; section at the module documentation for remaining options. Examples MyRepo.update_all(Post, set: [title: &quot;New title&quot;]) MyRepo.update_all(Post, inc: [visits: 1]) from(p in Post, where: p.id &lt; 10, select: p.visits) |&gt; MyRepo.update_all(set: [title: &quot;New title&quot;]) from(p in Post, where: p.id &lt; 10, update: [set: [title: &quot;New title&quot;]]) |&gt; MyRepo.update_all([]) from(p in Post, where: p.id &lt; 10, update: [set: [title: ^new_title]]) |&gt; MyRepo.update_all([]) from(p in Post, where: p.id &lt; 10, update: [set: [title: fragment(&quot;upper(?)&quot;, ^new_title)]]) |&gt; MyRepo.update_all([]) Callback implementation for Ecto.Repo.update_all/3."},{"ref":"StepFlow.Router.html","title":"StepFlow.Router","type":"module","doc":""},{"ref":"StepFlow.Router.html#call/2","title":"StepFlow.Router.call/2","type":"function","doc":"Callback implementation for Plug.call/2."},{"ref":"StepFlow.Router.html#init/1","title":"StepFlow.Router.init/1","type":"function","doc":"Callback implementation for Plug.init/1."},{"ref":"StepFlow.StatusView.html","title":"StepFlow.StatusView","type":"module","doc":""},{"ref":"StepFlow.StatusView.html#__phoenix_recompile__?/0","title":"StepFlow.StatusView.__phoenix_recompile__?/0","type":"function","doc":"Returns true whenever the list of templates changes in the filesystem."},{"ref":"StepFlow.StatusView.html#__resource__/0","title":"StepFlow.StatusView.__resource__/0","type":"function","doc":"The resource name, as an atom, for this view"},{"ref":"StepFlow.StatusView.html#__templates__/0","title":"StepFlow.StatusView.__templates__/0","type":"function","doc":"Returns the template root alongside all templates."},{"ref":"StepFlow.StatusView.html#render/2","title":"StepFlow.StatusView.render/2","type":"function","doc":"Renders the given template locally."},{"ref":"StepFlow.StatusView.html#template_not_found/2","title":"StepFlow.StatusView.template_not_found/2","type":"function","doc":"Callback invoked when no template is found. By default it raises but can be customized to render a particular template."},{"ref":"StepFlow.Step.html","title":"StepFlow.Step","type":"module","doc":"The Step context."},{"ref":"StepFlow.Step.html#skip_step/2","title":"StepFlow.Step.skip_step/2","type":"function","doc":""},{"ref":"StepFlow.Step.html#skip_step_jobs/2","title":"StepFlow.Step.skip_step_jobs/2","type":"function","doc":""},{"ref":"StepFlow.Step.html#start_next/1","title":"StepFlow.Step.start_next/1","type":"function","doc":""},{"ref":"StepFlow.Step.Helpers.html","title":"StepFlow.Step.Helpers","type":"module","doc":"The Helper Step context."},{"ref":"StepFlow.Step.Helpers.html#add_required_paths/2","title":"StepFlow.Step.Helpers.add_required_paths/2","type":"function","doc":""},{"ref":"StepFlow.Step.Helpers.html#filter_path_list/2","title":"StepFlow.Step.Helpers.filter_path_list/2","type":"function","doc":"Filter a list of paths. Examples iex&gt; StepFlow.Step.Helpers.filter_path_list([&quot;path_1.ext1&quot;, &quot;path2.ext2&quot;], [%{&quot;ends_with&quot; =&gt; &quot;.ext2&quot;}]) [&quot;path2.ext2&quot;] iex&gt; StepFlow.Step.Helpers.filter_path_list([&quot;path_1.ext1&quot;, &quot;path2.ext2&quot;], [%{ends_with: &quot;.ext2&quot;}]) [&quot;path2.ext2&quot;]"},{"ref":"StepFlow.Step.Helpers.html#get_base_directory/1","title":"StepFlow.Step.Helpers.get_base_directory/1","type":"function","doc":""},{"ref":"StepFlow.Step.Helpers.html#get_dates/0","title":"StepFlow.Step.Helpers.get_dates/0","type":"function","doc":""},{"ref":"StepFlow.Step.Helpers.html#get_job_destination_paths/1","title":"StepFlow.Step.Helpers.get_job_destination_paths/1","type":"function","doc":""},{"ref":"StepFlow.Step.Helpers.html#get_jobs_destination_paths/1","title":"StepFlow.Step.Helpers.get_jobs_destination_paths/1","type":"function","doc":""},{"ref":"StepFlow.Step.Helpers.html#get_required_paths/2","title":"StepFlow.Step.Helpers.get_required_paths/2","type":"function","doc":""},{"ref":"StepFlow.Step.Helpers.html#get_step_requirements/2","title":"StepFlow.Step.Helpers.get_step_requirements/2","type":"function","doc":""},{"ref":"StepFlow.Step.Helpers.html#get_value_in_parameters/2","title":"StepFlow.Step.Helpers.get_value_in_parameters/2","type":"function","doc":"Retrieve a value on an Object, filtered by the key"},{"ref":"StepFlow.Step.Helpers.html#get_value_in_parameters_with_type/3","title":"StepFlow.Step.Helpers.get_value_in_parameters_with_type/3","type":"function","doc":"Retrieve a value on an Object, filtered by the key and the type"},{"ref":"StepFlow.Step.Helpers.html#get_work_directory/0","title":"StepFlow.Step.Helpers.get_work_directory/0","type":"function","doc":""},{"ref":"StepFlow.Step.Helpers.html#template_process/4","title":"StepFlow.Step.Helpers.template_process/4","type":"function","doc":""},{"ref":"StepFlow.Step.Launch.html","title":"StepFlow.Step.Launch","type":"module","doc":"The Step launcher context."},{"ref":"StepFlow.Step.Launch.html#build_requirements_and_destination_path/6","title":"StepFlow.Step.Launch.build_requirements_and_destination_path/6","type":"function","doc":""},{"ref":"StepFlow.Step.Launch.html#generate_message_one_for_many/6","title":"StepFlow.Step.Launch.generate_message_one_for_many/6","type":"function","doc":""},{"ref":"StepFlow.Step.Launch.html#generate_message_one_for_one/7","title":"StepFlow.Step.Launch.generate_message_one_for_one/7","type":"function","doc":""},{"ref":"StepFlow.Step.Launch.html#get_source_paths/2","title":"StepFlow.Step.Launch.get_source_paths/2","type":"function","doc":""},{"ref":"StepFlow.Step.Launch.html#launch_step/3","title":"StepFlow.Step.Launch.launch_step/3","type":"function","doc":""},{"ref":"StepFlow.Step.Launch.html#start_job_one_for_many/6","title":"StepFlow.Step.Launch.start_job_one_for_many/6","type":"function","doc":""},{"ref":"StepFlow.WorkerDefinitionController.html","title":"StepFlow.WorkerDefinitionController","type":"module","doc":""},{"ref":"StepFlow.WorkerDefinitionController.html#create/2","title":"StepFlow.WorkerDefinitionController.create/2","type":"function","doc":""},{"ref":"StepFlow.WorkerDefinitionController.html#index/2","title":"StepFlow.WorkerDefinitionController.index/2","type":"function","doc":""},{"ref":"StepFlow.WorkerDefinitionController.html#show/2","title":"StepFlow.WorkerDefinitionController.show/2","type":"function","doc":""},{"ref":"StepFlow.WorkerDefinitionView.html","title":"StepFlow.WorkerDefinitionView","type":"module","doc":""},{"ref":"StepFlow.WorkerDefinitionView.html#__phoenix_recompile__?/0","title":"StepFlow.WorkerDefinitionView.__phoenix_recompile__?/0","type":"function","doc":"Returns true whenever the list of templates changes in the filesystem."},{"ref":"StepFlow.WorkerDefinitionView.html#__resource__/0","title":"StepFlow.WorkerDefinitionView.__resource__/0","type":"function","doc":"The resource name, as an atom, for this view"},{"ref":"StepFlow.WorkerDefinitionView.html#__templates__/0","title":"StepFlow.WorkerDefinitionView.__templates__/0","type":"function","doc":"Returns the template root alongside all templates."},{"ref":"StepFlow.WorkerDefinitionView.html#render/2","title":"StepFlow.WorkerDefinitionView.render/2","type":"function","doc":"Renders the given template locally."},{"ref":"StepFlow.WorkerDefinitionView.html#template_not_found/2","title":"StepFlow.WorkerDefinitionView.template_not_found/2","type":"function","doc":"Callback invoked when no template is found. By default it raises but can be customized to render a particular template."},{"ref":"StepFlow.WorkerDefinitions.html","title":"StepFlow.WorkerDefinitions","type":"module","doc":"The WorkerDefinitions context."},{"ref":"StepFlow.WorkerDefinitions.html#create_worker_definition/1","title":"StepFlow.WorkerDefinitions.create_worker_definition/1","type":"function","doc":"Creates a WorkerDefinition. Examples iex&gt; create_worker_definition(%{field: value}) {:ok, %WorkerDefinition{}} iex&gt; create_worker_definition(%{field: bad_value}) {:error, %Ecto.Changeset{}}"},{"ref":"StepFlow.WorkerDefinitions.html#exists/1","title":"StepFlow.WorkerDefinitions.exists/1","type":"function","doc":""},{"ref":"StepFlow.WorkerDefinitions.html#get_worker_definition!/1","title":"StepFlow.WorkerDefinitions.get_worker_definition!/1","type":"function","doc":"Gets a single WorkerDefinition. Raises Ecto.NoResultsError if the WorkerDefinition does not exist. Examples iex&gt; get_worker_definition!(123) %WorkerDefinition{} iex&gt; get_worker_definition!(456) ** (Ecto.NoResultsError)"},{"ref":"StepFlow.WorkerDefinitions.html#list_worker_definitions/1","title":"StepFlow.WorkerDefinitions.list_worker_definitions/1","type":"function","doc":"Returns the list of WorkerDefinitions. Examples iex&gt; list_worker_definitions() [%WorkerDefinition{}, ...]"},{"ref":"StepFlow.WorkflowController.html","title":"StepFlow.WorkflowController","type":"module","doc":""},{"ref":"StepFlow.WorkflowController.html#create/2","title":"StepFlow.WorkflowController.create/2","type":"function","doc":""},{"ref":"StepFlow.WorkflowController.html#delete/2","title":"StepFlow.WorkflowController.delete/2","type":"function","doc":""},{"ref":"StepFlow.WorkflowController.html#get/2","title":"StepFlow.WorkflowController.get/2","type":"function","doc":""},{"ref":"StepFlow.WorkflowController.html#index/2","title":"StepFlow.WorkflowController.index/2","type":"function","doc":""},{"ref":"StepFlow.WorkflowController.html#show/2","title":"StepFlow.WorkflowController.show/2","type":"function","doc":""},{"ref":"StepFlow.WorkflowController.html#statistics/2","title":"StepFlow.WorkflowController.statistics/2","type":"function","doc":""},{"ref":"StepFlow.WorkflowController.html#update/2","title":"StepFlow.WorkflowController.update/2","type":"function","doc":""},{"ref":"StepFlow.WorkflowEventsController.html","title":"StepFlow.WorkflowEventsController","type":"module","doc":""},{"ref":"StepFlow.WorkflowEventsController.html#handle/2","title":"StepFlow.WorkflowEventsController.handle/2","type":"function","doc":""},{"ref":"StepFlow.WorkflowView.html","title":"StepFlow.WorkflowView","type":"module","doc":""},{"ref":"StepFlow.WorkflowView.html#__phoenix_recompile__?/0","title":"StepFlow.WorkflowView.__phoenix_recompile__?/0","type":"function","doc":"Returns true whenever the list of templates changes in the filesystem."},{"ref":"StepFlow.WorkflowView.html#__resource__/0","title":"StepFlow.WorkflowView.__resource__/0","type":"function","doc":"The resource name, as an atom, for this view"},{"ref":"StepFlow.WorkflowView.html#__templates__/0","title":"StepFlow.WorkflowView.__templates__/0","type":"function","doc":"Returns the template root alongside all templates."},{"ref":"StepFlow.WorkflowView.html#render/2","title":"StepFlow.WorkflowView.render/2","type":"function","doc":"Renders the given template locally."},{"ref":"StepFlow.WorkflowView.html#template_not_found/2","title":"StepFlow.WorkflowView.template_not_found/2","type":"function","doc":"Callback invoked when no template is found. By default it raises but can be customized to render a particular template."},{"ref":"StepFlow.Workflows.html","title":"StepFlow.Workflows","type":"module","doc":"The Workflows context."},{"ref":"StepFlow.Workflows.html#change_workflow/1","title":"StepFlow.Workflows.change_workflow/1","type":"function","doc":"Returns an %Ecto.Changeset{} for tracking workflow changes. Examples iex&gt; change_workflow(workflow) %Ecto.Changeset{source: %Workflow{}}"},{"ref":"StepFlow.Workflows.html#create_workflow/1","title":"StepFlow.Workflows.create_workflow/1","type":"function","doc":"Creates a workflow. Examples iex&gt; create_workflow(%{field: value}) {:ok, %Workflow{}} iex&gt; create_workflow(%{field: bad_value}) {:error, %Ecto.Changeset{}}"},{"ref":"StepFlow.Workflows.html#delete_workflow/1","title":"StepFlow.Workflows.delete_workflow/1","type":"function","doc":"Deletes a Workflow. Examples iex&gt; delete_workflow(workflow) {:ok, %Workflow{}} iex&gt; delete_workflow(workflow) {:error, %Ecto.Changeset{}}"},{"ref":"StepFlow.Workflows.html#get_workflow!/1","title":"StepFlow.Workflows.get_workflow!/1","type":"function","doc":"Gets a single workflows. Raises Ecto.NoResultsError if the Workflow does not exist. Examples iex&gt; get_workflows!(123) %Workflow{} iex&gt; get_workflows!(456) ** (Ecto.NoResultsError)"},{"ref":"StepFlow.Workflows.html#get_workflow_history/1","title":"StepFlow.Workflows.get_workflow_history/1","type":"function","doc":""},{"ref":"StepFlow.Workflows.html#jobs_without_status?/2","title":"StepFlow.Workflows.jobs_without_status?/2","type":"function","doc":""},{"ref":"StepFlow.Workflows.html#list_workflows/1","title":"StepFlow.Workflows.list_workflows/1","type":"function","doc":"Returns the list of workflows. Examples iex&gt; list_workflows() [%Workflow{}, ...]"},{"ref":"StepFlow.Workflows.html#notification_from_job/1","title":"StepFlow.Workflows.notification_from_job/1","type":"function","doc":""},{"ref":"StepFlow.Workflows.html#update_workflow/2","title":"StepFlow.Workflows.update_workflow/2","type":"function","doc":"Updates a workflow. Examples iex&gt; update_workflow(workflow, %{field: new_value}) {:ok, %Workflow{}} iex&gt; update_workflow(workflow, %{field: bad_value}) {:error, %Ecto.Changeset{}}"},{"ref":"StepFlow.Workflows.StepManager.html","title":"StepFlow.Workflows.StepManager","type":"module","doc":"The Step Manager context."},{"ref":"StepFlow.Workflows.StepManager.html#check_step_status/1","title":"StepFlow.Workflows.StepManager.check_step_status/1","type":"function","doc":""},{"ref":"StepFlow.Workflows.StepManager.html#child_spec/1","title":"StepFlow.Workflows.StepManager.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"StepFlow.Workflows.StepManager.html#init/1","title":"StepFlow.Workflows.StepManager.init/1","type":"function","doc":"Invoked when the server is started. start_link/3 or start/3 will block until it returns. init_arg is the argument term (second argument) passed to start_link/3. Returning {:ok, state} will cause start_link/3 to return {:ok, pid} and the process to enter its loop. Returning {:ok, state, timeout} is similar to {:ok, state}, except that it also sets a timeout. See the &quot;Timeouts&quot; section in the module documentation for more information. Returning {:ok, state, :hibernate} is similar to {:ok, state} except the process is hibernated before entering the loop. See c:handle_call/3 for more information on hibernation. Returning {:ok, state, {:continue, continue}} is similar to {:ok, state} except that immediately after entering the loop the c:handle_continue/2 callback will be invoked with the value continue as first argument. Returning :ignore will cause start_link/3 to return :ignore and the process will exit normally without entering the loop or calling c:terminate/2. If used when part of a supervision tree the parent supervisor will not fail to start nor immediately try to restart the GenServer. The remainder of the supervision tree will be started and so the GenServer should not be required by other processes. It can be started later with Supervisor.restart_child/2 as the child specification is saved in the parent supervisor. The main use cases for this are: The GenServer is disabled by configuration but might be enabled later. An error occurred and it will be handled by a different mechanism than the Supervisor. Likely this approach involves calling Supervisor.restart_child/2 after a delay to attempt a restart. Returning {:stop, reason} will cause start_link/3 to return {:error, reason} and the process to exit with reason reason without entering the loop or calling c:terminate/2. Callback implementation for GenServer.init/1."},{"ref":"StepFlow.Workflows.StepManager.html#start_link/0","title":"StepFlow.Workflows.StepManager.start_link/0","type":"function","doc":""},{"ref":"readme.html","title":"step_flow","type":"extras","doc":"step_flow Step flow manager for Elixir applications"}]